#!/bin/bash

# Russian UTF-8 encoded
# =============================================
#  Dafturn Ofris Erdana - Locking your Systems
# =============================================
# Version       : 1.9.05-en
# Created by    : Dafturn Group Software
#                 The Mad Transition
# Author        : Muhammad Faruq Nuruddinsyah
# E-Mail        : faruq_dafturn@yahoo.co.id
# Date Creating : October, 12th 2008
# =============================================
# An Open Source from Indonesia
# =============================================

#----- Starting ----
echo 
echo "==================================================="
echo "    Dafturn Ofris Erdana - Заморозка системы"
echo "         By : Muhammad Faruq Nuruddinsyah"
echo "         adapted for pspo5+rus by : Denjs(c)"
echo "	       adapted for AltLinux 5.01 Master by : Xenar(c)"	
echo "==================================================="
echo 
echo "Выберите :"
echo "  1. Заморозить систему только для текущего пользователя"
echo "  2. Заморозить систему для заданного пользователя"
echo "  3. Заморозить систему для всех пользователей"
echo "  4. Разморозить систему"
echo "  5. Проверить статус"
echo "  6. Выход"
echo 
#-------------------

#----- Mendeklarasikan variabel -----
pam_local_file=/etc/pam.d/system-auth
is_opt=false 
is_success=true
ofris_n=6
ofris_tmp_co=1 
is_cho=false
#------------------------------------

#----- Awal script untuk menentukan pilihan -----
while [ $is_opt = false ]; do
echo -n "Введите номер выбранного пункта : "
read ofris_opt

if [[ $ofris_opt = 1 ]]; then
is_opt=true
ofris_tmp_co=1
elif [[ $ofris_opt = 2 ]]; then
is_opt=true
ofris_tmp_co=2
elif [[ $ofris_opt = 3 ]]; then
is_opt=true
ofris_tmp_co=3
elif [[ $ofris_opt = 4 ]]; then
is_opt=true
elif [[ $ofris_opt = 5 ]]; then
is_opt=true
elif [[ $ofris_opt = 6 ]]; then
is_opt=true
echo 
exit
else
echo "Извините, введен не верный номер... попробуйте ещё раз."
echo
is_opt=false
fi

done
#------------------------------------------------

#----- Script utama -----------------------------
if [[ $ofris_tmp_co = 1 ]]; then
ofris_user="${HOME:$ofris_n}"
elif [[ $ofris_tmp_co = 3 ]]; then
ofris_user=""
elif [[ $ofris_tmp_co = 2 ]]; then
is_cho=true
ofris_user=""
fi

grep -v "session optional pam_exec.so seteuid /etc/security/pam_exec" $pam_local_file > ofris_tmp
set $(wc -l ofris_tmp)
ofris_orig=$1
set $(wc -l $pam_local_file)
ofris_recnt=$1
ofris_rst=$[$ofris_recnt-$ofris_orig]
rm ofris_tmp

if [[ $ofris_opt = '1' || $ofris_opt = '2' || $ofris_opt = '3' ]]; then
#----- Mengunci sistem -----
echo 
echo "===== Заморозка системы ====="
echo 
echo "Пожалуйста подождите..."
echo 

####
#Блок срабатывает при выборе в меню 2 пункта и предназначен для задания имени пользователя для заморозки
####
if [[ $is_cho = true ]]; then
is_cho_suc=false
while [ $is_cho_suc = false ]; do
is_cho_suc=false
echo -n "Введите имя пользователя настройки которого будут заморожены : "
read ofris_cho
if [ -d "/home/$ofris_cho" ]; then
echo 
is_cho_suc=true
ofris_user=$ofris_cho
else
echo "Извините, такой пользователь не найден. Попробуйте ещё раз..."
echo 
fi
done
fi
####

if [ $ofris_rst = 1 ]; then 
echo "ОШИБКА : Система уже имеет блокировку.."
echo 
is_success=false
else

#####Устанавливаем скрипты в систему######
echo 'session optional pam_exec.so seteuid /etc/security/pam_exec' >> /etc/pam.d/system-auth
echo '#!/bin/bash' > /etc/security/pam_exec
echo 'case $PAM_TYPE in' >> /etc/security/pam_exec
echo '   open_session)' >> /etc/security/pam_exec
echo '                   run-parts /etc/pam_exec/login_scripts/' >> /etc/security/pam_exec
echo '               ;;' >> /etc/security/pam_exec 
echo '   close_session)' >> /etc/security/pam_exec
echo '                   run-parts /etc/pam_exec/logout_scripts/' >> /etc/security/pam_exec
echo '               ;;' >> /etc/security/pam_exec
echo 'esac' >> /etc/security/pam_exec
chmod 700 /etc/security/pam_exec
mkdir -p /etc/pam_exec/{login_scripts,logout_scripts}
echo "#!/bin/bash" > /etc/pam_exec/login_scripts/00-restore.sh
echo 'rsync -a --delete --exclude ".strigi" --exclude "Документы" --exclude "Видео" --exclude "Загрузки" --exclude "Изображения" --exclude "Музыка" --exclude ".mozilla" /etc/.ofris/$PAM_USER/ /home/$PAM_USER/' >> /etc/pam_exec/login_scripts/00-restore.sh
echo 'chown $PAM_USER:$PAM_USER -R /home/$PAM_USER' >> /etc/pam_exec/login_scripts/00-restore.sh
chmod 700 /etc/pam_exec/login_scripts/00-restore.sh
fi
######

if [ $is_success = true ]; then
if [ -d /etc/.ofris ]; then
rm -r /etc/.ofris
fi
if [ -d /etc/.ofris ]; then
rsync -a --delete --exclude '.strigi' --exclude 'Документы' --exclude 'Видео' --exclude 'Загрузки' --exclude 'Изображения' --exclude 'Музыка' --exclude '.mozilla' /home/$ofris_user /etc/.ofris/
chown root:root -R /etc/.ofris/$ofris_user
else
mkdir /etc/.ofris/
if [[ $ofris_user != "" ]]; then
mkdir /etc/.ofris/$ofris_user
fi
rsync -a --delete --exclude '.strigi' --exclude 'Документы' --exclude 'Видео' --exclude 'Загрузки' --exclude 'Изображения' --exclude 'Музыка' --exclude '.mozilla' /home/$ofris_user /etc/.ofris/
chown root:root -R /etc/.ofris/$ofris_user
fi
chmod +x $pam_local_file
fi

if [ $is_success = true ]; then
echo "Система успешно заморожена."
echo 
fi

elif [ $ofris_opt = '4' ]; then
#----- Membuka sistem -----
echo 
echo "===== Разморозка системы ====="
echo 
echo "Пожалуйста подождите..."
grep -v "session optional pam_exec.so seteuid /etc/security/pam_exec" $pam_local_file > ofris_tmp_b
rm $pam_local_file
cp ofris_tmp_b $pam_local_file
rm ofris_tmp_b
if [ -d /etc/.ofris ]; then
rm -r /etc/.ofris
rm /etc/security/pam_exec
rm -r /etc/pam_exec/
fi
echo 
echo "Система успешно разморожена..."
echo 

elif [ $ofris_opt = '5' ]; then
#----- Menampilkan status -----
if [ $ofris_rst = 1 ]; then
echo 
echo "===== Статус ====="
echo " Система заморожена..."
echo 
else
echo 
echo "===== Status ====="
echo " Система не имеет замороженных настроек..."
echo 
fi
fi

#----- Ending session -----
echo -n "[Нажмите любую клавишу для выхода...] "
read -s -n 1
echo 
echo 
